'****************************************************************
'*  Name    : Project solar chareger.BAS                        *
'*  Author  : [set under view...options]                        *
'*  Notice  : Copyright (c) 2005 [set under view...options]     *
'*          : All Rights Reserved                               *
'*  Date    : 25/12/2006                                        *
'*  Version : 1.0                                               *
'*  Notes   : Nattapon Jongroekmongkol SE-ED                    *
'*          : Semiconductor Electronic journal                  *
'****************************************************************
         include"modedefs.bas"
         
         define  osc  4
         
 '------- initial port ------------------------- 
         TRISB =%00000000
         PORTB =%00000000    ' PB.3 Charging
         TRISC =%00000000    ' PB.4 Take Load
         PORTC =%00000000    ' PB.5 Display Alarm
         pause 10
 '------- initial LCD  -------------------------          
         define LCD_DREG   PORTC
         define LCD_DBIT   4
         define LCD_RSREG  PORTA
         define LCD_RSBIT  4
         define LCD_EREG   PORTA
         define LCD_EBIT   5  
         define LCD_BITS   4 
 '------- initial register ADC -----------------          
         define ADC_BITS  10
         define ADC_CLOCK  3  
         define ADC_SAMPLEUS 500
         ADCON1.7 = 1  
 '------- Set variable --------------------------                   
         V_batt    var word
         V_solar   var word
         V_I_load  var word
      
         V_batt   =0  
         V_solar  =0  
         V_I_load =0
      
         GOsub  DISPLAY
 '------- Main program  -------------------------        
         
         IF V_batt>412 THEN Display_Stanby  ' V_Batt>11.5V go to Stanby
            goto  Charging                  ' and Below 11.5V goto Charger 
                   
         
 MAIN_load:                        
             IF  V_solar>375 THEN Charging  ' Solar>15V GO
         IF V_batt>431 THEN V_Batt_Hi     ' 12V
         IF V_batt>412 THEN V_Batt_Mid    ' 11.5V
         IF V_batt>394 THEN V_Batt_Low    ' 11V
         IF V_batt>370 THEN V_Batt_Alarm  ' 10.5V
                       
               Alarm:        
                     LOW   PORTB.2  
                     LOW   PORTB.1
                     LOW   PORTB.0
                     LOW   PORTB.4 ' OFF Load
                     HIGH  PORTB.5 ' LED Alarm ON
                     pause 100
                     LOW   PORTB.5 ' LED Alarm OFF
                     pause 100
                     GOsub DISPLAY
                           IF  V_solar>330 THEN Charging ' Solar>15V GO 
                     goto  Alarm
                         
               goto  MAIN_load
               
 '------- Display program 1  -------------------------         
      
 V_Batt_Hi:    high  PORTB.2 
               high  PORTB.4 ' ON Load 
               LOW   PORTB.1
               LOW   PORTB.0
               GOsub  DISPLAY 
               goto  MAIN_load
 V_Batt_Mid:   LOW   PORTB.2  
               high  PORTB.4 ' ON Load 
               HIGH  PORTB.1
               LOW   PORTB.0
               GOsub  DISPLAY 
               goto  MAIN_load
              
 V_Batt_Low:   LOW   PORTB.2 
               high  PORTB.4 ' ON Load  
               LOW   PORTB.1
               HIGH  PORTB.0
               GOsub  DISPLAY 
               goto  MAIN_load         
 V_Batt_Alarm: LOW   PORTB.2  
               LOW   PORTB.1
               LOW   PORTB.0
           '    LOW   PORTB.4 ' OFF Load
               HIGH  PORTB.5
               pause 300
               LOW   PORTB.5
               pause 300
               GOsub  DISPLAY 
               goto  MAIN_load 
               
 '------- Display LCD  ---------------------------               
               
 DISPLAY:  
   
         ADCIN   0,V_batt
         pause   10
         ADCIN   1,V_solar
         pause   10
         ADCIN   2,V_I_load
         pause   10
         
         lcdout  $fe,1
         lcdout  " Batt  sol  I lo " 
     
         lcdout  $fe,$C0
         lcdout  " ",dec V_batt,"   ",dec V_solar,"  ",dec V_I_load 
         pause   50
              IF  V_I_load>50 THEN LED_Alarm_ON  ' Check I Load ****************
                                                 ' Data 50 =5A
         return                                  '      30 =2.5A
         
 '------- Charger program  -------------------------   
 Charging:
          
          LOW   PORTB.4 ' OFF Load
          pause   1000
          LOW   PORTB.5 ' LED Alarm OFF
          high  PORTB.3 ' Charging
          pause   1000
          GOsub DISPLAY
          
              IF  V_batt>495 THEN Display_Stanby  ' V_Batt 13.8V  **************
          
      '         goto  Charging
          
          IF V_batt>485 THEN V_Hi_1_1   ' V_Batt 13.5V
          IF V_batt>431 THEN V_Mid_1_1  ' V_Batt 12V
          IF V_batt>412 THEN V_Low_1_1  ' V_Batt 11.5V
               goto  V_Low_1_1
 Charging_1:                 
               IF V_solar>245 THEN Charging  ' Solar>15V GO(375)13V=(330) ******    
                   low  PORTB.3 ' OFF Charging 
                   
                        IF  V_solar<230 THEN MAIN_load 'GOTO Take Load 10V  
                        GOsub DISPLAY
                   goto  Charging_1
                        
 Display_Stanby: 
         
          GOsub DISPLAY 
          LOW   PORTB.5 ' LED Alarm OFF
          LOW   PORTB.4 ' OFF Load       
          low   PORTB.3 ' OFF Charging  
     IF  V_solar<230 THEN MAIN_load 'GOTO Take Load 10V    *********************
              
          IF  V_batt>431 THEN V_Batt_Hi_1
          IF  V_batt>412 THEN V_Batt_Mid_1
          IF  V_batt>394 THEN V_Batt_Low_1
           ' batt fule 
                  
          goto  Alarm
          
 '------- Display program 2  -------------------------            
          
 V_Batt_Hi_1 :    high  PORTB.2 ' Display Hi
                  LOW   PORTB.1 ' Display Mid
                  LOW   PORTB.0 ' Display Low  
                  goto  Display_Stanby
 V_Batt_Mid_1:    LOW   PORTB.2 ' Display Hi
                  high  PORTB.1 ' Display Mid
                  LOW   PORTB.0 ' Display Low
                  goto  Display_Stanby
 V_Batt_Low_1:    LOW   PORTB.2 ' Display Hi
                  LOW   PORTB.1 ' Display Mid
                  high  PORTB.0 ' Display Low  
                  goto  Display_Stanby
                
 V_Hi_1_1 :       high  PORTB.2 ' Display Hi
                  LOW   PORTB.1 ' Display Mid
                  LOW   PORTB.0 ' Display Low  
                  goto  Charging_1
 V_Mid_1_1:       LOW   PORTB.2 ' Display Hi
                  high  PORTB.1 ' Display Mid
                  LOW   PORTB.0 ' Display Low
                  goto  Charging_1
 V_Low_1_1:       LOW   PORTB.2 ' Display Hi
                  LOW   PORTB.1 ' Display Mid
                  high  PORTB.0 ' Display Low  
                  goto  Charging_1               
 '------- Over Load off system  -------------------------               
 LED_Alarm_ON:               
                  LOW    PORTB.2  
                  LOW    PORTB.1
                  LOW    PORTB.0
                  LOW    PORTB.4 ' OFF Load
                  HIGH   PORTB.5 ' LED Alarm ON
                  pause  100
                  LOW    PORTB.5 ' LED Alarm OFF
                  pause  100
                  HIGH   PORTB.5 ' LED Alarm ON
                  pause  100
                  LOW    PORTB.5 ' LED Alarm OFF
                  pause  1000
                  goto   LED_Alarm_ON
                
                  end
         
         
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  

